#define CON_COM4 36		//CON_COM8 40
#define COM_BAUDRATE 57600

long input(0) servo0;
long input(1) servo1;
long input(2) servo2;
long input(3) servo3;
long input(4) speedRot;
long input(5) speed;
long input(6) execute;


long handle, sent, recieve;
long output(0) vystup1;
long output(1) vystup2;
long output(2) newPosition;


long buf[2];
long settings[30];

long data1, data2;	//odesilane packety


int init(void) {
	handle = Open(CON_COM4, COM_BAUDRATE, 0); //ta nula = dn parita
	//kdyz je handle<0, nastala chyba

	GetOptions(handle, settings);
	settings[17] = 100;
	settings[18] = 100;
	settings[19] = 100;
	settings[20] = 100;
	settings[21] = 100;
	SetOptions(handle, settings);

	return 0;
}



int SendOperationCommand(long data1, long data2) {
	long checkSum;
	long commandData[4];
	checkSum = (data1^data2) & 127;
	commandData[0] = 255;
	commandData[1] = data1;
	commandData[2] = data2;
	commandData[3] = checkSum;
	sent = Send(handle, commandData, 4);
	
	recieve = Recv(handle, buf, 2);
	vystup1 = buf[0];
	vystup2 = buf[1];


	return sent;
}

int SendSetCommand(long data1, long data2, long data3, long data4) {
	long checkSum;
	long setData[6];
	checkSum = (data1^data2^data3^data4) & 127;
	setData[0] = 255;
	setData[1] = data1;
	setData[2] = data2;
	setData[3] = data3;
	setData[4] = data4;
	setData[5] = checkSum;

	sent = Send(handle, setData, 6);

	recieve = Recv(handle, buf, 2);
	vystup1 = buf[0];
	vystup2 = buf[1];


	return 0;
}

int PositionSend(long motorID, long speedPosition, long position) {
	if (speedPosition <= 4 && speedPosition >= 0)
		data1 = (speedPosition << 5) | motorID;
	else return -1;
	if (position <= 255 && position >= 0)
		SendOperationCommand(data1, position);
	else return -1;

	return 0;
}

int PositionRead(long motorID) {
	data1 = (5 << 5) | motorID;
	
	SendOperationCommand(data1, 0);

	return 0;
}





int PositionSendIncrement(long motorID, long speed, long direction, long step) {

        long newPosition;
	

	PositionRead(motorID);
	if (speed <= 4 && speed >= 0)
		data1 = (speed << 5) | motorID;
	else return -1;
	

	if (direction>0)
		newPosition=vystup2+step;
	else
		newPosition=vystup2-step;
	
	if (newPosition <= 255 && newPosition >= 0)
		SendOperationCommand(data1, newPosition);
	else return -1;

	return 0;
}

int main(void) {
	if (execute > 0) {  
			PositionSend(0, speed, servo0);
			PositionSend(1, speedRot, servo1);
			PositionSend(2, speedRot, servo2);
			PositionSend(3, speed, servo3);
	}
		else return -1;
	

	return 0;
}

int exit(void) {
	if (handle >= 0) Close(handle);
	return 0;
}

